//+------------------------------------------------------------------+
//|                                                  LeManSignal.mq4 |
//|                                         Copyright  2009, LeMan. |
//|                                                 b-market@mail.ru |
//+------------------------------------------------------------------+
//mod
#property copyright "Copyright  2009, LeMan."
#property link      "b-market@mail.ru"
//----
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Blue

#property indicator_width1 2
#property indicator_width2 2
#property indicator_style3 0
#property indicator_style4 0
//----
extern bool AlertOn=true;


extern int MaPeriod=5;
extern int porog = 30;
extern int metod =1;
extern int metod2 =1;
extern int PRICE1 = 0;
extern int N      = 1;       
             
//----
double OpenUp[];
double OpenDown[];

double OpenUpLv[];
double OpenDownLv[];


//+------------------------------------------------------------------+
int init() {
//----
   string short_name;
//----
   IndicatorDigits(Digits);
   IndicatorBuffers(4);
//----
   short_name = "LeManSignal ("+N+")";
   IndicatorShortName(short_name);
//----      
   SetIndexBuffer(0,OpenUp);
   SetIndexBuffer(1,OpenDown);  

   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);     
                 
   SetIndexStyle(0,DRAW_ARROW,EMPTY,2);
   SetIndexArrow(0,159);
   SetIndexStyle(1,DRAW_ARROW,EMPTY,2);
   SetIndexArrow(1,159);

   SetIndexLabel(0, "O");
   SetIndexLabel(1, "O");   
 
 
 
   SetIndexBuffer(2,OpenUpLv);
   SetIndexBuffer(3,OpenDownLv);  

   SetIndexLabel(2, "O");
   SetIndexLabel(3, "O");   
 
 
      
//----
   return(0);
}
//+------------------------------------------------------------------+
int start() { 
   
   double LevelStop = MarketInfo(Symbol(),14);    

   int counted_bars = IndicatorCounted();      
   if (counted_bars > 0) counted_bars--;
   static datetime bt;
   int limit;
   limit = Bars - counted_bars;
  
   for (int i = limit; i >= 0; i--) {
            
      
      
      
          
      
      //double L = iLow("AUDUSD", 0, i+1);
      //double L2 = iLow("AUDUSD", 0, i+2);
      double H1 = iHigh("AUDUSD", 0, iHighest("AUDUSD", 0, MODE_HIGH, N, i+1));
      double H2 = iHigh("AUDUSD", 0, iHighest("AUDUSD", 0, MODE_HIGH, N, i+1+N));
      double H3 = iHigh("AUDUSD", 0, iHighest("AUDUSD", 0, MODE_HIGH, N, i+2));
      double H4 = iHigh("AUDUSD", 0, iHighest("AUDUSD", 0, MODE_HIGH, N, i+2+N));      
      double L1 = iLow("AUDUSD", 0, iLowest("AUDUSD", 0, MODE_LOW, N, i+1));
      double L2 = iLow("AUDUSD", 0, iLowest("AUDUSD", 0, MODE_LOW, N, i+1+N));
      double L3 = iLow("AUDUSD", 0, iLowest("AUDUSD", 0, MODE_LOW, N, i+2));
      double L4 = iLow("AUDUSD", 0, iLowest("AUDUSD", 0, MODE_LOW, N, i+2+N));  
      double CL  = iClose("AUDUSD",0,i+1);
      double OP  = iOpen("AUDUSD",0,i+1); 
      double CL3  = iClose("AUDUSD",0,i+3);    
      double XMA = iCustom("AUDUSD",0,"Xma",MaPeriod,porog,metod,metod2,0,0,i+1);
      
      double H1E = iHigh("EURUSD", 0, iHighest("EURUSD", 0, MODE_HIGH, N, i+1));
      double H2E = iHigh("EURUSD", 0, iHighest("EURUSD", 0, MODE_HIGH, N, i+1+N));
      double H3E = iHigh("EURUSD", 0, iHighest("EURUSD", 0, MODE_HIGH, N, i+2));
      double H4E = iHigh("EURUSD", 0, iHighest("EURUSD", 0, MODE_HIGH, N, i+2+N));      
      double L1E = iLow("EURUSD", 0, iLowest("EURUSD", 0, MODE_LOW, N, i+1));
      double L2E = iLow("EURUSD", 0, iLowest("EURUSD", 0, MODE_LOW, N, i+1+N));
      double L3E = iLow("EURUSD", 0, iLowest("EURUSD", 0, MODE_LOW, N, i+2));
      double L4E = iLow("EURUSD", 0, iLowest("EURUSD", 0, MODE_LOW, N, i+2+N));     
      double CLE  = iClose("EURUSD",0,i+1);
      double OPE  = iOpen("EURUSD",0,i+1); 
      double CL3E  = iClose("EURUSD",0,i+3);    
      double XMAE = iCustom("EURUSD",0,"Xma",MaPeriod,porog,metod,metod2,0,0,i+1);
      
      double XMA2 = iCustom(NULL,0,"Xma",MaPeriod,porog,metod,metod2,0,0,i+1);
      double CL1 = iClose(NULL,0,i+1);  
      
      
      OpenUpLv[i] = OpenUpLv[i+1];        OpenDownLv[i] = OpenDownLv[i+1];

      OpenUp[i] = EMPTY_VALUE;            OpenDown[i] = EMPTY_VALUE;
            
                           
      if (( L3 >= L4 && L1 < L2 &&  CL >= XMA && OP > CL && CL1 < XMA2)
          ||  (L3E >= L4E && L1E < L2E &&  CLE >= XMAE && OPE > CLE && CL1 < XMA2 )) {
         OpenUp[i] = High[i+1] + Point;
         OpenUpLv[i]  =OpenUp[i];
      }
          
      if (( H3 <= H4 && H1 > H2 &&  CL <= XMA && OP < CL && CL1 > XMA2)
          ||  (H3E <= H4E && H1E > H2E &&  CLE <= XMAE && OPE < CLE && CL1 > XMA2 )) {
         OpenDown[i] = Low[i+1] - Point;         
         OpenDownLv[i]=OpenDown[i];
      }    

  }
   if(AlertOn) {
      if((OpenUp[1]==EMPTY_VALUE && OpenUp[0]!=EMPTY_VALUE)||(OpenDown[1]==EMPTY_VALUE && OpenDown[0]!=EMPTY_VALUE)) {
         if(bt!=Time[0])   {
            Alert(Symbol()+"_M"+Period()+": ! :)");
            bt=Time[0];
         }
      }
   }
//----
   return(0);
}
//+------------------------------------------------------------------+